/*
 * TuxNES
 *
 * Written by Benjamin C. W. Sittler for TuxNES
 *
 * Description: sound interface
 *
 * $Id: sound.h,v 1.2 2000/07/08 02:17:12 bsittler Exp $
 */

/* exports */
extern int	InitAudio(int argc, char **argv);
extern void	UpdateAudio(void);

struct SampleFormat {
     char *name, *fullname;
     int number;
};

/* the currently selected sample format */
extern struct SampleFormat *sample_format;

/* table of sample formats, terminated by { 0, 0, 0, 0 } */
extern struct SampleFormat sample_formats[];

/* lookup table for 12bit->Mu-Law sample conversion */
extern unsigned char ulaw [0x4000];

/* global sound parameters */
extern struct SoundConfig {
     char	*audiofile;
     int	audiorate;
     int	audiostereo;
     float	max_sound_delay;
     int	reverb;
     int	use_sin;
} sound_config;

/* global sound data */
extern struct SoundData {
     int	SQR1_FR2_write;
     int	SQR2_FR2_write;
     int	TRI_FR2_write;
     int	NOI_FR2_write;
} sound_data;
